<?php
// $Id: opendover.wsclient.inc,v 1.2 2009/07/26 10:41:41 johnnyvdlaar Exp $

/**
 * TODO: write descr.
 * @file
 */

// PHP classes corresponding to the data types in defined in WSDL
class loadSubjectDomainsResponse {
  
  /**
   * @var array[0, unbounded] of (object)dtoSubjectDomain
   */
  public $return;
  
}

class dtoSubjectDomain {
  
  /**
   * @var string
   */
  public $code;
  
  /**
   * @var string
   */
  public $name;
  
}

// define the class map
$class_map = array(
    "loadSubjectDomainsResponse" => "loadSubjectDomainsResponse",
    "dtoSubjectDomain" => "dtoSubjectDomain");

/**
 *
 */
function load_subject_domains_from_server() {
  try {
    $subject_domains = array();
    $server_url = variable_get('opendover_service_url', "http://java.opinionmining.nl") ."/WSOpenDoverService?wsdl";
    // create client in WSDL mode
    $client = new SoapClient($server_url, array("connection_timeout" => 60, "classmap" => $class_map));
    
    // call the operation
    $response = $client->loadSubjectDomains();
    
    if (is_array($response->return)) {
      foreach ($response->return as $subject_domain)
        $subject_domains[$subject_domain->code] = $subject_domain->name;
    }
    else {
      $subject_domain = $response->return;
      $subject_domains[$subject_domain->code] = $subject_domain->name;
    }
    return $subject_domains;
      
  } 
  catch (Exception $e) {
    // in case of an error, process the fault
    if ($e instanceof WSFault) {
      printf("Soap Fault: %s\n", $e->getMessage());
    } 
    else {
      printf("Message = %s\n", $e->getMessage());
    }
  }    
}